/* predicate.c generated by valac 0.54.6, the Vala compiler
 * generated from predicate.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2017 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "seahorse-common.h"
#include <glib-object.h>
#include <glib.h>
#include <string.h>

/**
     * Matches a seahorse object and a predicate
     *
     * @param obj The predicate to match
     *
     * @return false if predicate does not match the Object, true else
     */
gboolean
seahorse_predicate_match (SeahorsePredicate *self,
                          GObject* obj)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp7_ = FALSE;
	SeahorsePredicateFunc _tmp8_;
	gboolean result = FALSE;
	g_return_val_if_fail (obj != NULL, FALSE);
	if ((*self).type != ((GType) 0)) {
		gboolean _tmp1_ = FALSE;
		if (g_type_is_a (G_TYPE_FROM_INSTANCE (obj), (*self).type)) {
			_tmp1_ = g_type_is_a ((*self).type, G_TYPE_FROM_INSTANCE (obj));
		} else {
			_tmp1_ = FALSE;
		}
		_tmp0_ = !_tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	if ((*self).usage != SEAHORSE_USAGE_NONE) {
		SeahorseUsage obj_usage = 0;
		SeahorseUsage _tmp2_ = 0;
		obj_usage = SEAHORSE_USAGE_NONE;
		g_object_get (obj, "usage", &_tmp2_, NULL, NULL);
		obj_usage = _tmp2_;
		if ((*self).usage != obj_usage) {
			result = FALSE;
			return result;
		}
	}
	if ((*self).flags != 0) {
		_tmp3_ = TRUE;
	} else {
		_tmp3_ = (*self).nflags != 0;
	}
	if (_tmp3_) {
		SeahorseFlags obj_flags = 0U;
		SeahorseFlags _tmp4_ = 0U;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		obj_flags = SEAHORSE_FLAG_NONE;
		g_object_get (obj, "object-flags", &_tmp4_, NULL, NULL);
		obj_flags = _tmp4_;
		if ((*self).flags != SEAHORSE_FLAG_NONE) {
			_tmp5_ = ((*self).flags & obj_flags) == obj_flags;
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			result = FALSE;
			return result;
		}
		if ((*self).nflags != SEAHORSE_FLAG_NONE) {
			_tmp6_ = !(((*self).nflags & obj_flags) == obj_flags);
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			result = FALSE;
			return result;
		}
	}
	_tmp8_ = (*self).custom;
	if (_tmp8_ != NULL) {
		SeahorsePredicateFunc _tmp9_;
		void* _tmp10_;
		_tmp9_ = (*self).custom;
		_tmp10_ = (*self).custom_target;
		_tmp7_ = !_tmp9_ (obj, _tmp10_);
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}

SeahorsePredicate*
seahorse_predicate_dup (const SeahorsePredicate* self)
{
	SeahorsePredicate* dup;
	dup = g_new0 (SeahorsePredicate, 1);
	memcpy (dup, self, sizeof (SeahorsePredicate));
	return dup;
}

void
seahorse_predicate_free (SeahorsePredicate* self)
{
	g_free (self);
}

 G_GNUC_NO_INLINE static GType
seahorse_predicate_get_type_once (void)
{
	GType seahorse_predicate_type_id;
	seahorse_predicate_type_id = g_boxed_type_register_static ("SeahorsePredicate", (GBoxedCopyFunc) seahorse_predicate_dup, (GBoxedFreeFunc) seahorse_predicate_free);
	return seahorse_predicate_type_id;
}

GType
seahorse_predicate_get_type (void)
{
	static volatile gsize seahorse_predicate_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_predicate_type_id__volatile)) {
		GType seahorse_predicate_type_id;
		seahorse_predicate_type_id = seahorse_predicate_get_type_once ();
		g_once_init_leave (&seahorse_predicate_type_id__volatile, seahorse_predicate_type_id);
	}
	return seahorse_predicate_type_id__volatile;
}

